camera = {}
camera._x = 0
camera._y = 0
camera.scaleX = 1
camera.scaleY = 1
camera.rotation = 0


function camera:set()
  love.graphics.push()
  love.graphics.rotate(-self.rotation)
  love.graphics.scale(1 / self.scaleX, 1 / self.scaleY)
  love.graphics.translate(-self._x,-self._y)
end

function camera:unset()
  love.graphics.pop()
end

function camera:move(dx, dy)
  if dx then self:setX(self._x + (dx or 0)) end
  if dy then self:setY(self._y + (dy or 0)) end
end

function camera:rotate(dr)
  self.rotation = self.rotation + dr
end

function camera:scale(sx, sy)
  sx = sx or 1
  self.scaleX = self.scaleX * sx
  self.scaleY = self.scaleY * (sy or sx)
end

function camera:setX(value)
  if self._bounds then
    self._x = clamp(value, self._bounds.x1/self.scaleX, self._bounds.x2/self.scaleX)
  else
    self._x = value
  end
end

function camera:setY(value)
  if self._bounds then
    self._y = clamp(value, self._bounds.y1/self.scaleY, self._bounds.y2/self.scaleY)
  else
    self._y = value
  end
end

function camera:setPosition(x, y)
  if x then self:setX(x) end
  if y then self:setY(y) end
end

function camera:setScale(sx, sy)
  self.scaleX = sx or self.scaleX
  self.scaleY = sy or self.scaleY
end

function camera:getBounds()
  return unpack(self._bounds)
end

function camera:setBounds(x1, y1, x2, y2)
  self._bounds = { x1 = x1, y1 = y1, x2 = x2, y2 = y2 }
end

function clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end