	require "camera"
	require "maps"

	function love.load()
		love.physics.setMeter(64) --the height of a meter our worlds will be 64px
		world = love.physics.newWorld(0, 9.81*64, true) --create a world for the bodies to exist in with horizontal gravity of 0 and vertical gravity of 9.81
		love.graphics.setLineWidth(3)
		
		linecolour = {180, 200, 10}
  		first = true
		first2 = true
		first3 = true
		cameraspeed = 1000
		scale = 1
		scalespeed = 0.05
		maxscale = 3
		minscale = 1
		ballamount = 0
		ballsin = 0
		create = "Ledge"
	
		objects = {} -- table to hold all our physical objects
		line = {}
		objects.winbox = {}
		objects.deathbox = {}
		objects.cantbuild = {}
		objects.ledge = {}
		objects.worldob = {}
		objects.ball = {}
		objects.staticball = {}
		objects.ballgate = {}
		currentob = 1
		currentmapob = 1
		currentgateob = 1
		currentwinboxob = 1
		currentball = 1
		currentstaticball = 1
		currentcantbuild = 1
		currentdeathbox = 1
		mapnum = 4
 
		stringlength = 5000
		--love.graphics.getWidth(), love.graphics.getHeight()
  
		--let's create a ball
		 --let the ball bounce

		--initial graphics setup
		love.graphics.setBackgroundColor(104, 136, 248) --set the background color to a nice blue
		love.graphics.setMode(650, 650, false, true, 0) --set the window dimensions to 650 by 650
		mapload(mapnum)
end
 
	function love.mousepressed( x, y, mb )	
		if mb == "wd" then
			scale = clamp(scale + scalespeed,minscale,maxscale)
			camera.scaleX = scale
			camera.scaleY = scale
		end

		if mb == "wu" then
			scale = clamp(scale - scalespeed,minscale,maxscale)
			camera.scaleX = scale
			camera.scaleY = scale
		end
	end

	function love.update(dt)
		world:update(dt) --this puts the world into motion
		DRAW_LEDGE()
		
		if love.keyboard.isDown("right") then 
			camera:move(cameraspeed*dt,0)
		elseif love.keyboard.isDown("left") then 
			camera:move(-cameraspeed*dt,0)
		end
		if love.keyboard.isDown("up") then 
			camera:move(0,-cameraspeed*dt)
		elseif love.keyboard.isDown("down") then
			camera:move(0,cameraspeed*dt)
		end
		if love.keyboard.isDown("r") then
			cleanlevel()
			mapload(mapnum)
		end
		if love.keyboard.isDown("1") then -- changing tools
			create = "Ledge"
		elseif love.keyboard.isDown("2") then
			create = "Bouncy Ledge"
		elseif love.keyboard.isDown("3") then
			create = "Spiny Circle"
		end
		if love.keyboard.isDown(" ") then
			if first3 then
				deleteall(objects.ballgate)
				first3 = false
			else
			for i = #objects.ball,1,-1 do
				objects.ball[i].body:setPosition(objects.ball[i].originx,objects.ball[i].originy)
				objects.ball[i].body:setLinearVelocity(0,0.1)
				objects.ball[i].body:setAngularVelocity(0,0)
			end
			end
			
		end
		for i = #objects.ball, 1,-1 do
			for x = #objects.staticball, 1,-1 do
				if  cheakcollision(objects.staticball[x].body:getX()-objects.ball[i].shape:getRadius()-objects.ball[i].shape:getRadius()/10
				,objects.staticball[x].body:getX()+objects.ball[i].shape:getRadius()+objects.ball[i].shape:getRadius()/10
				,objects.staticball[x].body:getY()-objects.ball[i].shape:getRadius()-objects.ball[i].shape:getRadius()/10
				,objects.staticball[x].body:getY()+objects.ball[i].shape:getRadius()+objects.ball[i].shape:getRadius()/10
				,objects.ball[i].body:getX()-objects.ball[i].shape:getRadius()
				,objects.ball[i].body:getX()+objects.ball[i].shape:getRadius()
				,objects.ball[i].body:getY()-objects.ball[i].shape:getRadius()
				,objects.ball[i].body:getY()+objects.ball[i].shape:getRadius()) then -- if ball hits static ball
					objects.ball[i].body:applyAngularImpulse(objects.staticball[x].strength)
				end
			end
		
			if cheakcollision(objects.winbox[1],objects.winbox[1]+maps.tilesize,objects.winbox[2],objects.winbox[2]+maps.tilesize
			,objects.ball[i].body:getX()-objects.ball[i].shape:getRadius()
			,objects.ball[i].body:getX()+objects.ball[i].shape:getRadius()
			,objects.ball[i].body:getY()-objects.ball[i].shape:getRadius()
			,objects.ball[i].body:getY()+objects.ball[i].shape:getRadius()) then -- if ball goes in win box
			ballsin = ballsin +1
			objects.ball[i].body:destroy()
			table.remove (objects.ball,i)
			end
			if ballsin == ballamount then
			mapnum = mapnum + 1
			cleanlevel()
			mapload(mapnum)
			end
		end
	end

	function love.draw()
		love.graphics.setColor(0,0,0)
		love.graphics.print(create,10,50,0,2,2)
		camera:set()
		love.graphics.setColor(100,0,0,100)
		for i = 1, #objects.cantbuild do -- cantbuild box
			love.graphics.rectangle("fill", objects.cantbuild[i].x1,objects.cantbuild[i].y1,maps.tilesize,maps.tilesize)
		end
		
		for i = 1, #objects.ledge do -- ledges
		love.graphics.setColor(objects.ledge[i].color)
			love.graphics.polygon("fill", objects.ledge[i].body:getWorldPoints(objects.ledge[i].shape:getPoints()))
		end
		
		love.graphics.setColor(50,50,50,200)--walls
		for i = 1, #objects.worldob do
			love.graphics.polygon("fill", objects.worldob[i].body:getWorldPoints(objects.worldob[i].shape:getPoints()))
		end
		love.graphics.setColor(200,100,50,100)--ballgate
		for i = 1, #objects.ballgate do
			love.graphics.polygon("fill", objects.ballgate[i].body:getWorldPoints(objects.ballgate[i].shape:getPoints()))
		end
		
			
		for i = 1, #objects.ball do -- balls
			love.graphics.setColor(objects.ball[i].color)
			love.graphics.circle("fill", objects.ball[i].body:getX(), objects.ball[i].body:getY(), objects.ball[i].shape:getRadius())
		end
		
		for i = 1, #objects.staticball do -- staticballs
			love.graphics.setColor(255,130,255,150)
			love.graphics.circle("fill", objects.staticball[i].body:getX(), objects.staticball[i].body:getY(), objects.staticball[i].shape:getRadius())
			love.graphics.setColor(50,50,50,150)
			if objects.staticball[i].strength > 0 then
				love.graphics.rectangle("fill",objects.staticball[i].body:getX(), objects.staticball[i].body:getY(),objects.staticball[i].shape:getRadius(),3)
			else
				love.graphics.rectangle("fill",objects.staticball[i].body:getX(), objects.staticball[i].body:getY(),-objects.staticball[i].shape:getRadius(),3)
			end
		end
		love.graphics.setColor(0,255,0,200)
		love.graphics.rectangle("fill", objects.winbox[1],objects.winbox[2],maps.tilesize,maps.tilesize)
		
		camera:unset()
		
		love.graphics.setColor(linecolour)
		love.graphics.line(line.x1,line.y1,line.x2,line.y2)
		
		love.graphics.setColor(0, 0, 0)
		love.graphics.print(tostring(math.floor(stringlength)),midpoint(10,stringlength/10),7,0,2,2)
		if first == false then
			love.graphics.print(tostring(math.floor(finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale))), midpoint(line.x1,line.x2),  midpoint(line.y1,line.y2),0,2,2)
		end
		love.graphics.setColor(0,0,0,100)
		love.graphics.rectangle("fill",10,5,stringlength/10,30)
		end
  
	function DRAW_LEDGE()
	if love.mouse.isDown("l") and not love.mouse.isDown("r") then
		linecolour = {180, 200, 10}
		if first == true then
			line.x1 = love.mouse.getX()
			line.y1 = love.mouse.getY()
			first = false
		end
			line.x2 = love.mouse.getX()
			line.y2 = love.mouse.getY()
	end
	if not love.mouse.isDown("l") and not love.mouse.isDown("r") then
		if first == false then
		if lineinbuildarea() == true then
			if create == "Ledge" then
			if finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale) > 3 then
				if finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale) < math.floor(stringlength) then
				objects.ledge[currentob] = {}
				objects.ledge[currentob].body = love.physics.newBody(world, midpoint(line.x1*scale+camera._x,line.x2*scale+camera._x),  midpoint(line.y1*scale+camera._y,line.y2*scale+camera._y))
				objects.ledge[currentob].shape = love.physics.newRectangleShape(0,0,finddist(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y),3,findanglebetween(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y))
				objects.ledge[currentob].fixture = love.physics.newFixture(objects.ledge[currentob].body,objects.ledge[currentob].shape)
				objects.ledge[currentob].length = finddist(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y)
				objects.ledge[currentob].color = {50,50,50}
				stringlength = stringlength - finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale)
				currentob = currentob +1
				end
			end
			end
			if create == "Bouncy Ledge" then
				if finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale) > 3 then
				if finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale) < math.floor(stringlength) then
				objects.ledge[currentob] = {}
				objects.ledge[currentob].body = love.physics.newBody(world, midpoint(line.x1*scale+camera._x,line.x2*scale+camera._x),  midpoint(line.y1*scale+camera._y,line.y2*scale+camera._y))
				objects.ledge[currentob].shape = love.physics.newRectangleShape(0,0,finddist(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y),3,findanglebetween(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y))
				objects.ledge[currentob].fixture = love.physics.newFixture(objects.ledge[currentob].body,objects.ledge[currentob].shape)
				objects.ledge[currentob].fixture:setRestitution(1.6)
				objects.ledge[currentob].length = finddist(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y)
				objects.ledge[currentob].color = {200,50,50}
				stringlength = stringlength - finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale)
				currentob = currentob +1	
			end
			end
			end
			if create == "Spiny Circle" then
			if finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale) > 3 then
				if finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale) < math.floor(stringlength) then
				objects.staticball[currentstaticball] = {}
				objects.staticball[currentstaticball].body = love.physics.newBody(world, midpoint(line.x1*scale+camera._x,line.x2*scale+camera._x),  midpoint(line.y1*scale+camera._y,line.y2*scale+camera._y))
				objects.staticball[currentstaticball].shape = love.physics.newCircleShape(finddist(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y)/2)
				objects.staticball[currentstaticball].fixture = love.physics.newFixture(objects.staticball[currentstaticball].body,objects.staticball[currentstaticball].shape)
				objects.staticball[currentstaticball].fixture:setFriction(10)
				objects.staticball[currentstaticball].length = finddist(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y)
				objects.staticball[currentstaticball].strength = objects.staticball[currentstaticball].shape:getRadius()*10000
				objects.staticball[currentstaticball].angle = findanglebetween(line.x1*scale+camera._x,line.x2*scale+camera._x,line.y1*scale+camera._y,line.y2*scale+camera._y)
				if math.abs(math.deg(findanglebetween(line.x1,line.x2,line.y1,line.y2)))>90  then
					objects.staticball[currentstaticball].strength = -objects.staticball[currentstaticball].strength 
				end
				objects.staticball[currentstaticball].color = {255,130,255}
				stringlength = stringlength - finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale)
				currentstaticball = currentstaticball +1	
			end
			end
			end
		end
			first = true
			line.x1 = 0
			line.x2 = 0
			line.y1 = 0
			line.y2 = 0
		end
	end
	if love.mouse.isDown("r") and not love.mouse.isDown("l") then
		linecolour = {250,70,10}
		if first2 == true then
			line.x1 = love.mouse.getX()
			line.y1 = love.mouse.getY()
			first2 = false
		end
			line.x2 = love.mouse.getX()
			line.y2 = love.mouse.getY()
	end
	if not love.mouse.isDown("r") and not love.mouse.isDown("l") then
		if first2 == false then
			if finddist(line.x1*scale,line.x2*scale,line.y1*scale,line.y2*scale) > 3 then
			world:rayCast(line.x1*scale+camera._x, line.y1*scale+camera._y, line.x2*scale+camera._x, line.y2*scale+camera._y, worldRayCastCallback)
			end
			line.x1 = 0
			line.x2 = 0
			line.y1 = 0
			line.y2 = 0
			first2 = true
		end
	end
	end

	function finddist(x1,x2,y1,y2)
	return math.sqrt(((x2-x1)^2)+((y2-y1)^2))
	end

	function midpoint(point1,point2)
			mid = (point1+point2)/2
		return mid
	end

	function worldRayCastCallback(fixture, x, y, xn, yn, fraction)
    local hit = {}
    hit.fixture = fixture
    hit.x, hit.y = x, y
    hit.xn, hit.yn = xn, yn
    hit.fraction = fraction
	
	for i = #objects.staticball, 1, -1 do
		if objects.staticball[i].fixture == hit.fixture then
			stringlength = stringlength + objects.staticball[i].length
			objects.staticball[i].body:destroy()
			table.remove(objects.staticball,i)
			currentstaticball = currentstaticball -1
		end
	end
	
	
	for i = #objects.ledge, 1, -1 do
		if objects.ledge[i].fixture == hit.fixture then
			stringlength = stringlength + objects.ledge[i].length
			objects.ledge[i].body:destroy()
			table.remove(objects.ledge,i)
			currentob = currentob -1
		end
	end
	
    return 1 -- Continues with ray cast through all shapes.
end
	
	function findanglebetween(x1,x2,y1,y2)
		deltax = x2 - x1
		deltay = y2 - y1
		a  = math.rad(math.atan2(deltay, deltax) * 180 / math.pi)
	 return	a
	end
	
	function deleteall(array)
		for i = #array, 1, -1 do
			array[i].body:destroy()
			table.remove(array,i)
		end
	end
	
	function mapload(num)
	if maps:load(num) then 
		stringlength = maps.stringamount
		for y = 0,maps.sizey do
			for x = 1, maps.sizex do
				if maps.map[x+y*maps.sizex] == 0.5 then
					objects.cantbuild[currentcantbuild] = {}
					objects.cantbuild[currentcantbuild].x1 = x*maps.tilesize-maps.tilesize/2
					objects.cantbuild[currentcantbuild].y1 = y*maps.tilesize-maps.tilesize/2
					currentcantbuild = currentcantbuild +1
				end
				if maps.map[x+y*maps.sizex] == 1 then --make static box
					camera:setBounds(maps.tilesize,maps.tilesize,maps.sizex*maps.tilesize,maps.sizey*maps.tilesize)
					objects.worldob[currentmapob] = {}
					objects.worldob[currentmapob].body = love.physics.newBody(world, x*maps.tilesize,y*maps.tilesize)
					objects.worldob[currentmapob].shape = love.physics.newRectangleShape(0,0,maps.tilesize,maps.tilesize)
					objects.worldob[currentmapob].fixture = love.physics.newFixture(objects.worldob[currentmapob].body,objects.worldob[currentmapob].shape)
					currentmapob = currentmapob +1
				end
				if maps.map[x+y*maps.sizex] == 2 then -- ball
					objects.ball[currentball] = {}
					camera:setPosition(x*maps.tilesize/2,y*maps.tilesize/2)
					camera.scaleX = 1
					camera.scaleY = 1
					ballamount = ballamount+1
					scale = 1
					objects.ball[currentball].body = love.physics.newBody(world, x*maps.tilesize,y*maps.tilesize, "dynamic") --place the body in the center of the world and make it dynamic, so it can move around
					objects.ball[currentball].shape = love.physics.newCircleShape(20) --the ball's shape has a radius of 20
					objects.ball[currentball].fixture = love.physics.newFixture(objects.ball[currentball].body, objects.ball[currentball].shape, 1) -- Attach fixture to body and give it a density of 1.
					objects.ball[currentball].fixture:setRestitution(0.2)
					objects.ball[currentball].body:setLinearVelocity(0,0)
					objects.ball[currentball].body:setLinearDamping(0.1)
					objects.ball[currentball].color = {0,0,255}
					objects.ball[currentball].originx = x*maps.tilesize
					objects.ball[currentball].originy = y*maps.tilesize
					currentball = currentball +1
				end
				if maps.map[x+y*maps.sizex] == 2.5 then -- ball
					objects.ball[currentball] = {}
					camera:setPosition(x*maps.tilesize/2,y*maps.tilesize/2)
					camera.scaleX = 1
					camera.scaleY = 1
					ballamount = ballamount+1
					scale = 1
					objects.ball[currentball].body = love.physics.newBody(world, x*maps.tilesize,y*maps.tilesize, "dynamic") --place the body in the center of the world and make it dynamic, so it can move around
					objects.ball[currentball].shape = love.physics.newCircleShape(20) --the ball's shape has a radius of 20
					objects.ball[currentball].fixture = love.physics.newFixture(objects.ball[currentball].body, objects.ball[currentball].shape, 1) -- Attach fixture to body and give it a density of 1.
					objects.ball[currentball].fixture:setRestitution(0.9)
					objects.ball[currentball].body:setLinearVelocity(0,0)
					objects.ball[currentball].body:setLinearDamping(0.1)
					objects.ball[currentball].color = {255,0,0}
					objects.ball[currentball].originx = x*maps.tilesize
					objects.ball[currentball].originy = y*maps.tilesize
					currentball = currentball +1
				end
				if maps.map[x+y*maps.sizex] == 3 then -- win box
					objects.winbox = {x*maps.tilesize-maps.tilesize/2,y*maps.tilesize-maps.tilesize/2}
				end
				if maps.map[x+y*maps.sizex] == 4 then
					objects.ballgate[currentgateob] = {}
					objects.ballgate[currentgateob].body = love.physics.newBody(world, x*maps.tilesize,y*maps.tilesize)
					objects.ballgate[currentgateob].shape = love.physics.newRectangleShape(0,0,maps.tilesize,maps.tilesize)
					objects.ballgate[currentgateob].fixture = love.physics.newFixture(objects.ballgate[currentgateob].body,objects.ballgate[currentgateob].shape)
					currentgateob = currentgateob+1
				end
			end
	end
	end
	end
	
	function cheakcollision(x1,x2,y1,y2,xx1,xx2,yy1,yy2)
		return x1 < xx2 and x2 > xx1 and y1 < yy2 and y2 > yy1
	end
	
	function cleanlevel()
		currentmapob = 1
		currentob = 1
		currentcantbuild = 1
		currentdeathbox = 1
		currentstaticball = 1
		currentwinboxob = 1
		currentball = 1
		ballsin = 0
		ballamount = 0
		first3 = true
		currentgateob = 1
		deleteall(objects.ball)
		deleteall(objects.ledge)
		deleteall(objects.staticball)
		for i = #objects.cantbuild,1,-1 do
			table.remove(objects.cantbuild,i)
		end
		deleteall(objects.worldob)
		deleteall(objects.ballgate)	
	end
	
	function lineinbuildarea()
		for i = #objects.cantbuild, 1,-1 do
			if boxSegmentIntersection(objects.cantbuild[i].x1,objects.cantbuild[i].y1,maps.tilesize,maps.tilesize,line.x1*scale+camera._x,line.y1*scale+camera._y,line.x2*scale+camera._y,line.y2*scale+camera._y) then
			return false
			end
		end		
		return true
	end
	
  function boxSegmentIntersection(l,t,w,h, x1,y1,x2,y2)
  local dx, dy  = x2-x1, y2-y1

  local t0, t1  = 0, 1
  local p, q, r

  for side = 1,4 do
    if     side == 1 then p,q = -dx, x1 - l
    elseif side == 2 then p,q =  dx, l + w - x1
    elseif side == 3 then p,q = -dy, y1 - t
    else                  p,q =  dy, t + h - y1
    end

    if p == 0 then
      if q < 0 then return false end  -- Segment is parallel and outside the bbox
    else
      r = q / p
      if p < 0 then
        if     r > t1 then return false 
        elseif r > t0 then t0 = r
        end
      else -- p > 0
        if     r < t0 then return false 
        elseif r < t1 then t1 = r
        end
      end
    end
  end
  return true
end